/*
  rtfhbann.c
     Includes banner text and DisplayBanner()

  rtfhcp85.c
     Includes ANSI to CP850 conversion software

  rtfhdata.c
     Includes RTFHelp globals

  rtfhhelp.c
     Includes help text and argument processing

  rtfhmain.c
     The main proc

  rtfhpars.c
     The text parser
*/

  enum Commands
  {
    bitmapcharacter, bold, box, browseseq, build,
    centeralign, comment, contextID,
    deffont, defformat, definelink, definepopup, deftab,
    firstlineindent, font, fontsize, foregroundcolor,
    italic,
    justified,
    keep, keepnext, keyword,
    marginbottom, marginleft, marginright, margintop,
    leftalign, leftindent,
    newparagraph, newpage,
    pard, plain, plaintext, putlink, putpopup,
    requiredlinebreak, rightalign, rightindent,
    smallcaps, spaceafter, spacebefore, spacebetween, spacechar,
    tab, tabbar, tabcenter, tabdec, tabpos, tabright, title,
    xrefID,
    undefined
  } ;

#define NOOFCMDS  56
#define TRUE     1
#define FALSE    0
#define RTFH_TOKENSIZE          800
#define RTFH_BUFFERSIZE         4096
#define RTFH_BUFFER2SIZE        255

struct COMMANDENTRY
{
  char         *strCmd ;
  enum Commands idCmd ;
} ;

#define RC_OK                 0
#define RC_NOTSUPPORTEDTHISVERSION      100
#define INVALID_NO_OF_PARAMS  1
#define FOPEN_RETURNED_NULL   2
#define USER_ABORT            3
#define LIBRARY_ERROR         4
#define INTERNAL_ERROR       13

// functional prototypes
int main(int argc, char **argv) ;
int write_head(FILE *) ;
int write_tail(FILE *) ;
int Tokenize(FILE *flInput, FILE *flOutput, char *Line) ;
int TranslateCPToANSI(int codepage, char *str) ;
int ProcessArgs(int argc, char *argv[]) ;
int SetUpGeneration(char *GenString) ;
int DoGeneration(FILE *In, FILE *Out) ;
int DoSecondGeneration(FILE **In, FILE **Out) ;
int GetRTFToken(char **bufferpos, char *Token, int OnlySpaces) ;
int TransWriteToken(char *Token, int TokenType, FILE *Out) ;
void DisplayBanner(void) ;

typedef unsigned char UCHAR ;
typedef int BOOL ;

// include extern definitions in all files except RTFHData.c
  #ifndef  NO_EXTERNS
     extern  char Token[] ;                  // RTFH_TOKENSIZE
     extern  char szBuffer[] ;               // RTFH_BUFFERSIZE
     extern  char szBuffer2[] ;              // RTFH_BUFFER2SIZE
     extern  char cBufferPos ;

     extern  char *pszInput ;
     extern  char *pszOutput ;
     extern  BOOL bOverwrite ;
     extern  BOOL bCondense ;
     extern  BOOL bVerbose ;
     extern  BOOL bGeneratingHDC ;

     extern  int  codepage ;
     extern  char hardspace ;

     extern  char SecPassName[] ;
     extern  char FirPassName[] ;
     extern struct COMMANDENTRY CommandList[] ;
  #endif

